#include <complex.h>
#include <fftw3.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#define L (1<<25)
///#define NT 2


void print_timediff(struct timespec ts_start,struct timespec ts_end){
  struct timespec ts_diff;
    
  ts_diff.tv_sec = ts_end.tv_sec - ts_start.tv_sec;
  ts_diff.tv_nsec = ts_end.tv_nsec - ts_start.tv_nsec;
  if (ts_diff.tv_nsec > 1000000000) {
    ts_diff.tv_sec++;
    ts_diff.tv_nsec -= 1000000000;
  }
  if (ts_diff.tv_nsec < 0) {
    ts_diff.tv_sec--;
    ts_diff.tv_nsec += 1000000000;
  }
  
  fprintf(stderr,"Elapsed time: %.3f sec\n ", ts_diff.tv_sec+(1.0e-9)*ts_diff.tv_nsec);
}

void main(void){
  int n;
  short unsigned int seed[3];
  fftw_complex * A;
  struct timespec ts_start;
  struct timespec ts_end;
  seed[0] = 123;
  seed[1] = 456;
  seed[2] = 789;
  seed48(seed);

  A = (fftw_complex *)fftw_malloc(L*sizeof(fftw_complex));
  int i;
  for (i=0;i<L;i++) A[i] = (fftw_complex)(drand48()+I*drand48());
  

  fftw_init_threads();

  fftw_complex *in   = (fftw_complex *)fftw_malloc(L*sizeof(fftw_complex));
  fftw_complex *out  = (fftw_complex *)fftw_malloc(L*sizeof(fftw_complex));
  
  fftw_plan_with_nthreads(NT);
  fftw_plan FP = fftw_plan_dft_1d(L,in,out,1,FFTW_ESTIMATE);
  fftw_free(in);
  fftw_free(out);
  
  fftw_complex *fft   = (fftw_complex *)fftw_malloc(L*sizeof(fftw_complex));
  
  clock_gettime(CLOCK_MONOTONIC, &ts_start);
  for (i=0;i<10;i++) fftw_execute_dft(FP,A,fft);
  clock_gettime(CLOCK_MONOTONIC, &ts_end);
  print_timediff(ts_start,ts_end);
  
}
