#include <stdlib.h>
#include <stdio.h>
#include <mkl.h>
// C-wrapper to the Frotran LApack lib.
#include <mkl_lapacke.h>

int main() {
 
  int n=2000;
  printf("Matrix size=%i\n",n);	
  printf("Number of threads=%i\n",mkl_get_max_threads());	

  MKL_INT N = n, LDA = n, info,i,j;
  double w[N];
  MKL_Complex16* a; a=malloc(N*LDA*sizeof(MKL_Complex16));
  
  srand(999); // No randomness, for reproducibility
  /* dense random matrix */
  printf("Random Hermitian matrix.\n");
  for (i=0; i < N; i++ )
    for(j = 0; j<N; j++ )
      a[i*LDA+j].real=rand(),a[i*LDA+j].imag=rand();
  
  // LAPACKE_zheevd: computes all eigenvalues and eigenvectors of a complex Hermitian
  // matrix A using divide and conquer algorithm

  info = LAPACKE_zheevd( LAPACK_ROW_MAJOR, 'V', 'L', N, a, LDA, w );
  
  /* Check for coNvergence */
  if( info > 0 ) {
    printf( "The algorithm failed to compute eigenvalues.\n" );
    exit( 1 );
  }
  /* Print eigenvalues */
  printf("Smallest eigen value=%6.2f\n",w[0]); 
  printf("Largest value=%6.2f\n\n",w[N-1]); 
}
