#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <lapacke.h> // C-wrapper to the Frotran LApack lib.

int main() {
const int N=2000;
const int LDA=N;
printf("Matrix size=%i\n",N);	
printf("Number of threads=%i\n",omp_get_max_threads());	

int info,i,j;
double w[N];
lapack_complex_double* a; a=malloc(N*LDA*sizeof(lapack_complex_double));

srand(999); // No randomness, for reproducibility
/* dense random matrix */
printf("Random Hermitian matrix.\n");
for (i=0; i < N; i++ ) for(j = 0; j<N; j++ )
a[i*LDA+j]=lapack_make_complex_double(rand(),rand());

// LAPACKE_zheevd: computes all eigenvalues and eigenvectors of a complex Hermitian
// matrix A using divide and conquer algorithm
info = LAPACKE_zheevd( LAPACK_ROW_MAJOR, 'V', 'L', N, a, LDA, w );

/* Check for convergence */
if( info > 0 ) {
	printf( "The algorithm failed to compute eigenvalues.\n" );
	exit( 1 );
}
/* Print the extreme eigenvalues */
printf("Smallest eigen value=%6.2f\n",w[0]); 
printf("Largest value=%6.2f\n\n",w[N-1]); 
}

