import numpy as np
import multiprocessing as mp
import numpy.random as npr
import time

def smallest_ev(M):
	ev=np.linalg.eigvals(M)
	return ev[0].real

p=mp.Pool(processes=2)
#Two random matrices:
n=3000
A=npr.randn(n,n)
B=npr.randn(n,n)
t0 = time.time()
results=p.imap_unordered(smallest_ev, [A,B])
t1 = time.time() - t0
print(" Time after .imap_unordered=%0.4f s" % (t1))
for r in results:
	print (r)
t1 = time.time() - t0
print(" Time after print results=%0.4f s" % (t1))

t0 = time.time()
print(smallest_ev(A))
print(smallest_ev(B))
t1 = time.time() - t0
print(" Sequential time=%0.4f s" % (t1))

