import numpy as np
import numpy.random as npr
import time

npr.seed(2019)

###sizes=[10,20,50,100,127,128,129,200,300,400,500,511,512,513,600,700,800,900,1000,1023,1024,1025,2000,2047,2048,2049,3000,4000,6000,8000,10000,12000]
sizes=[10,20,50,100,200,300,400,500,600,700,800,900,1000,2000,3000,4000,6000,8000,10000,12000]

with open("Eigvals.dat",'w') as my_file:
    my_file.write("#n\ttime\tnum_threads\n")
    for n in sizes:
        A = npr.randn(n,n)
        t = time.time()
        v=np.linalg.eigvals(A)
        td = time.time() - t
        print("Eigenvals of (%d,%d) matrix in %0.4f s" % (n, n, td))
        my_file.write(str(n)+"\t"+str(td)+"\n")

with open("matmul.dat",'w') as my_file:
    my_file.write("#n\ttime\tnum_threads\n")
    for n in sizes:
        A = npr.randn(n,n)
        B = npr.randn(n,n)
        t = time.time()
        v=np.matmul(A,B)
        td = time.time() - t
        print("Multiplication of two (%d,%d) matrix in %0.4f s" % (n, n, td))
        my_file.write(str(n)+"\t"+str(td)+"\n")

with open("eigvalsh.dat",'w') as my_file:
    my_file.write("#n\ttime\tnum_threads\n")
    for n in sizes:
        A = npr.randn(n,n)
        t = time.time()
        v=np.linalg.eigvalsh(A)
        td = time.time() - t
        print("Diag. of a real-sym. (%d,%d) matrix in %0.4f s" % (n, n, td))
        my_file.write(str(n)+"\t"+str(td)+"\n")

with open("svd.dat",'w') as my_file:
    my_file.write("#n\ttime\tnum_threads\n")
    for n in sizes:
        A = npr.randn(int(n/2),n)
        t = time.time()
        u, s, vh = np.linalg.svd(A)
        td = time.time() - t
        print("SVD of a (%d,%d) matrix in %0.4f s" % (n/2, n, td))
        my_file.write(str(n)+"\t"+str(td)+"\n")
